//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSandyBrown
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_buffers 9
#property strict

#property strict


//
//
//
//
//


enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};
enum enColorOn
{
   col_colorOnSlope,  // Change color on slope change
   col_colorOnLevelo, // Change color on outer level cross
   col_colorOnLevelm  // Change color on middle level cross
};

extern enPrices  Price           = pr_median;      // Price to use
extern int       Length          = 25;             // Inverse of driving coefficient
extern int       Damping         =  5;             // Smoothing percent
extern int       MaxGap          = 30;             // Maximum gap ignored (pips)
extern int       Shift           =  0;             // Shift
extern int       flLookBack      = 25;             // Floating levels lookback period
extern double    flLevelUp       = 90;             // Floating levels up level %
extern double    flLevelDown     = 10;             // Floating levels down level %
extern enColorOn colorOn         = col_colorOnSlope; // Color change
extern color     colorUp         = clrDeepSkyBlue; // Color for up
extern color     colorDown       = clrSandyBrown;  // Color for down
extern color     colorNeutral    = clrSilver;      // Color for neutral
extern color     colorShadow     = clrDimGray;     // Color for "shadow"
extern int       linesWidth      = 3;              // Lines width

double avg[],avgda[],avgdb[],avgua[],avgub[],shadow[],slope[],flu[],flm[],fld[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,flu);    SetIndexStyle(0,EMPTY,STYLE_DOT,0,colorUp);
   SetIndexBuffer(1,flm);    SetIndexStyle(1,EMPTY,STYLE_DOT,0,colorNeutral);
   SetIndexBuffer(2,fld);    SetIndexStyle(2,EMPTY,STYLE_DOT,0,colorDown);
   SetIndexBuffer(3,shadow); SetIndexStyle(3,EMPTY,EMPTY,linesWidth+6,colorShadow);
   SetIndexBuffer(4,avg);    SetIndexStyle(4,EMPTY,EMPTY,linesWidth  ,colorNeutral);
   SetIndexBuffer(5,avgda);  SetIndexStyle(5,EMPTY,EMPTY,linesWidth  ,colorDown);
   SetIndexBuffer(6,avgdb);  SetIndexStyle(6,EMPTY,EMPTY,linesWidth  ,colorDown);
   SetIndexBuffer(7,avgua);  SetIndexStyle(7,EMPTY,EMPTY,linesWidth  ,colorUp);
   SetIndexBuffer(8,avgub);  SetIndexStyle(8,EMPTY,EMPTY,linesWidth  ,colorUp);
   SetIndexBuffer(9,slope);
      for (int i=0; i<9; i++) SetIndexShift(i,Shift);
   IndicatorShortName("Tim Moris MMA ("+(string)Length+", "+(string)Damping+", "+(string)MaxGap+", "+(string)Shift+")");    
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][3];
#define _price 0
#define _y1    1
#define _y2    2

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   double GapLimit = MaxGap*Point*MathPow(10,MathMod(Digits,2));
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   if (slope[limit]==-1) CleanPoint(limit,avgda,avgdb);
   if (slope[limit]== 1) CleanPoint(limit,avgua,avgub);
   for(int i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      work[r][_price] = getPrice(Price,Open,Close,High,Low,i);
      if (r<1) { avg[i] = work[r][_price]; continue; }
         double y1 = work[r-1][_y1];
         double y2 = work[r-1][_y2];
         
            if ((High[i]<Low[i+1]) || (Low[i]>High[i+1]))
            {
               double gap = work[r][_price]-work[r-1][_price];
   	      		if (MathAbs(gap)>GapLimit)
                  {
                     y1 = avg[i+1]+gap;
                     y2 = avg[i+2]+gap;
                  }
            }            
            
            double noise  = MathMax(High[i]-Low[i],0.000001);
            double err    = (work[r][_price]-2.0*y1+y2)/noise; 
            double drv    = MathMax(MathMin((1.0/Length)*err*err+(1.0/Length)*MathAbs(err),0.5),0.0);
            double dmp    = MathMax(MathMin((1.0/Length)*MathAbs(y1-y2)/noise + Damping/100.0,1.0),0.0);
         
            //
            //
            //
            //
            //
         
            avg[i]       = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
            work[r][_y1] = avg[i];
            work[r][_y2] = y1;
            shadow[i]    = avg[i];
            slope[i] = slope[i+1];      
            avgda[i] = EMPTY_VALUE;
            avgdb[i] = EMPTY_VALUE;
            avgua[i]  = EMPTY_VALUE;
            avgub[i]  = EMPTY_VALUE;
               double min   = avg[ArrayMinimum(avg,flLookBack,i)];
               double max   = avg[ArrayMaximum(avg,flLookBack,i)];
               double range = max-min;
                  flu[i]    = min+flLevelUp*range/100.0;
                  fld[i]    = min+flLevelDown*range/100.0;
                  flm[i]    = min+0.5*range;
      
            //
            //
            //
            //
            //
      
            if (i<Bars-1)
            {
               slope[i] = slope[i+1];
               switch (colorOn)
               {
                  case col_colorOnSlope :
                        if (avg[i]>avg[i+1]) slope[i]= 1;
                        if (avg[i]<avg[i+1]) slope[i]=-1;
                        break;
                  case col_colorOnLevelm :
                        if (avg[i]>flm[i]) slope[i]= 1;
                        if (avg[i]<flm[i]) slope[i]=-1;
                        break;
                  default :
                        slope[i] = 0;
                        if (avg[i]>flu[i]) slope[i]= 1;
                        if (avg[i]<fld[i]) slope[i]=-1;
               }                                             
            }
            if (slope[i]==-1) PlotPoint(i,avgda,avgdb,avg);
            if (slope[i]== 1) PlotPoint(i,avgua,avgub,avg);
   }   
   return(0);           
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}
